Bug 525371

Summary: [CJK] vertical clock time text rotated wrong way
Product: [Fedora] Fedora Reporter: Jens Petersen <petersen>
Component: gnome-panelAssignee: Ray Strode [halfline] <rstrode>
Status: CLOSED WONTFIX QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: low    
Version: 17CC: behdad, i18n-bugs, mclasen, rstrode, tagoh, tfujiwar, t.matsuu
Target Milestone: ---Keywords: MoveUpstream, Triaged
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-07-25 02:49:50 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Attachments:
Description Flags
f12-vert-clock.png
none
f11-vert-clock.png
none
screenshot without the gravity hack none

Description Jens Petersen 2009-09-24 00:57:25 EDT
Created attachment 362429 [details]
f12-vert-clock.png

Description of problem:
In F12 the rotation of vertical text seems to have changed.
For Chinese, Japanese and Korean the time is opposite
direction to the date also.

Version-Release number of selected component (if applicable):


How reproducible:
every time

Steps to Reproduce:
1. start CJK gnome desktop
2. create a left panel
3. add clock
  
Actual results:
see screenshot

Expected results:
closer to f11 would be better
(ideally ideally should be vertical not rotated)
Comment 1 Jens Petersen 2009-09-24 03:19:30 EDT
Created attachment 362442 [details]
f11-vert-clock.png
Comment 2 Matthias Clasen 2009-09-24 11:47:04 EDT
Behdad, is this a pango issue ?
Comment 3 Behdad Esfahbod 2009-09-24 13:50:01 EDT
Jens, can you attach a screenshot of how this was before?  And more importantly, how it should be?
Comment 4 Behdad Esfahbod 2009-09-24 13:52:25 EDT
Oh, I see what you mean.  I think this is caused by a hack Vincent put in gnome-panel back then when pango's vertical support was buggy.  Should not be needed now.  Lemme track upstream.
Comment 5 Behdad Esfahbod 2009-09-24 14:19:26 EDT
https://bugzilla.gnome.org/show_bug.cgi?id=410169
Comment 6 Behdad Esfahbod 2009-09-24 14:22:00 EDT
https://bugzilla.gnome.org/show_bug.cgi?id=596215
Comment 7 Matthias Clasen 2009-09-24 23:33:13 EDT
Created attachment 362606 [details]
screenshot without the gravity hack

As you can see, still not perfect without the workaround.
Comment 8 Jens Petersen 2009-09-25 04:56:29 EDT
(In reply to comment #7)
> Created an attachment (id=362606) [details]
> screenshot without the gravity hack
> 
> As you can see, still not perfect without the workaround.  

This the same as the original attachment.
Comment 9 Jens Petersen 2009-09-25 05:05:45 EDT
(In reply to comment #6)
> https://bugzilla.gnome.org/show_bug.cgi?id=596215  

Hmm the problem is actually more complex:

a) pure ascii words should be rotated: eg "time: 12:34"

b) but not the numbers in mixed text: eg 1月23日

(strictly the date numerals should be converted to widechars
perhaps but I think that is non-trivial to do,
so just not rotating digits would work ok).

c) however the parens should be rotated: eg (日)
(though we could use widechar parens for this)
Comment 10 Matthias Clasen 2009-09-25 08:13:33 EDT
> This the same as the original attachment.  

No, its not. Compare the parens.
Comment 11 Behdad Esfahbod 2009-09-25 22:12:33 EDT
Humm, I need to think more about how this is supposed to be handled.  Using wide chars for digits should not be too hard.  That said, I'm not quite sure where the regression comes from.  Need some more testing.
Comment 12 Behdad Esfahbod 2009-09-25 22:13:39 EDT
Filed this: https://bugzilla.gnome.org/show_bug.cgi?id=596394
Comment 13 Jens Petersen 2009-09-27 20:14:27 EDT
(In reply to comment #10)
> > This the same as the original attachment.  
> 
> No, its not. Compare the parens.  

Perhaps you're looking at my f11 screenshot? :)

Attachment 362429 [details] with ipa looks the same
as your attachment 362606 [details] with droid to me.
Comment 14 Matthias Clasen 2009-09-27 20:35:42 EDT
my screenshot has no droid in it
Comment 15 Takanori MATSUURA 2009-09-27 21:48:35 EDT
Section 2.3.2.b and 3.2.[3-6] in the document of "Requirements for Japanese Text Layout" may help to understand the vertical layout (at least) in Japanese.
http://www.w3.org/TR/jlreq/

In case of clock applet in vertical side bar, we need to consider which side is up and down in the display.

This means that vertical clock should be shown as the following in any case the side bar exists at right or left side.

(<> means to set rotated 90 degrees clockwise in vertical writing mode)

9
月
24
日

<13:53:34>

or

9
月
24
日

午
後
<1:53:34>
Comment 16 Jens Petersen 2009-09-28 03:42:39 EDT
(In reply to comment #14)
> my screenshot has no droid in it  

(Well the heavy Japanese font is Droid Sans Japanese AFAICT.)

(In reply to comment #15)
> [..] 3.2.[3-6] in the document of "Requirements for Japanese
> Text Layout" may help to understand the vertical layout (at least) in
> Japanese. http://www.w3.org/TR/jlreq/

Thanks that is indeed a very thorough and useful reference.

> This means that vertical clock should be shown as the following in any case
> the side bar exists at right or left side.

This also applies to the the default panel menu:
"Applications" should appear first at the top if vertical
not "System", whether the panel is on the left or right.

> (<> means to set rotated 90 degrees clockwise in vertical writing mode)
> 
> 9
> 月
> 24
> 日
> 
> <13:53:34>
> 
> or
> 
> 9
> 月
> 24
> 日
> 
> 午
> 後
> <1:53:34>  

A couple of comments:

1) I guess one important point is the order: note it is different
to currently: the date should appear before time in Japanese
(ie above if using vertical text).

2) Rotating the time clockwise seems unnatural to me when on the left
I would prefer vertical time:

1
3
<:>
5
3
<:>
3
4

or

13
<:>
53
<:>
34

or

午
後
1
<:>
53
<:>
34


(To honest though I would prefer just rotating the Japanese date-time
(panel text) a la European than have a half-working vertical display.)
Comment 17 Jens Petersen 2009-09-28 03:44:45 EDT
(In reply to comment #16)
> 2) Rotating the time clockwise seems unnatural to me when on the left
<break>
> I would prefer vertical time:
Comment 18 fujiwara 2009-09-28 05:28:18 EDT
The problem is not clock applet only so I'd like to see the fix in the pango or gtk+.
Comment 19 fujiwara 2009-09-28 05:55:14 EDT
> 13
> <:>
> 53
> <:>
> 34

Sounds good when I write a Japanese address in a Japanese letter.
Comment 20 fujiwara 2009-10-05 04:39:31 EDT
I'm a bit confused about the implementation.

When Orientation "Left" is chosen with gnome-panel property dialog, The angle is 90 and gtk_label_set_angle (label, 90) is called.

On English locales:
The base gravity is PANGO_GRAVITY_WEST and the resolved gratity of latin script is PANGO_GRAVITY_SOUTH.
It means the string orientation is bottom to top.

On Japanese locales:
The base gravity is PANGO_GRAVITY_WEST and the resolved gratity of hun/kana script is PANGO_GRAVITY_WEST.
It means the string orientation is top to bottom.


Is it better that the latin strip orientation is also top to bottom on the panel?
Fedora GNOME Panel has the application menu who has icon, "Application", "Places", "System" menus.
Is the widget orientation is top to bottom when Orientation "Left" is chosen ?

Currently GtkLabel provides the rotate API(gtk_label_set_angle) however a flip API for strings likes gdk_pixbuf_flip() maybe nice in the panel property so that Orientation "Left" and "Right" are mirrored.
Comment 21 fujiwara 2009-10-05 04:52:10 EDT
Correction:

> Is it better that the latin strip orientation is also top to bottom on the
panel?

Is it better that the latin string orientation is also top to bottom on the
panel in case that the orientation is left?
Comment 22 Matthias Clasen 2009-10-05 13:13:13 EDT
Assigning to Behdad.
Comment 23 Behdad Esfahbod 2009-10-05 15:34:25 EDT
No, the Latin orientation is right.  Please continue discussion upstream if you don't mind.
Comment 24 Jens Petersen 2009-10-05 23:04:02 EDT
Ok - I linked the gnome bug as external above
 - assuming that is the right one.

Currently I would suggest just not making any text
vertical in the panel at all until we have a good solution
and just rotate it for all langs.
Comment 25 Bug Zapper 2009-11-16 07:50:20 EST
This bug appears to have been reported against 'rawhide' during the Fedora 12 development cycle.
Changing version to '12'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 26 Jens Petersen 2010-11-04 02:15:16 EDT
Still happening with gnome-panel-2.32.0.2-2.fc14.
Comment 27 Bug Zapper 2010-11-04 05:51:10 EDT
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 28 Akira TAGOH 2011-12-05 06:21:46 EST
Is this still valid on GNOME3? Jens, any thought?
Comment 29 Jens Petersen 2012-03-05 00:24:45 EST
Yes for F16 gnome-panel at least.
Comment 30 Jens Petersen 2012-03-05 00:31:30 EST
and F17
Comment 31 Fedora End Of Life 2013-07-04 02:45:47 EDT
This message is a reminder that Fedora 17 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 17. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '17'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 17's end of life.

Bug Reporter:  Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 17 is end of life. If you 
would still like  to see this bug fixed and are able to reproduce it 
against a later version  of Fedora, you are encouraged  change the 
'version' to a later Fedora version prior to Fedora 17's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 32 Jens Petersen 2013-07-04 06:22:54 EDT
I think also applies for MATE panel.
Comment 33 Wolfgang Ulbrich 2013-07-04 06:42:37 EDT
(In reply to Jens Petersen from comment #32)
> I think also applies for MATE panel.
You're only thinking that this issue ocours with mate-panel, or are you shure?
And if you're shure please add a screenshot from the issue with current Mate release (f18/f19).

Thank you
Comment 34 Wolfgang Ulbrich 2013-07-04 09:15:09 EDT
Jens,
i don't see this issue in MATE.
Pls stop assigning old gnome bugs to MATE without testing.
Comment 35 Jens Petersen 2013-07-04 21:56:31 EDT
Thanks Wolfgang - sorry you are right, indeed the numerals
are all oriented the same way in mate-panel's clock applet.

(Ideally the numerals should be vertical for Japanese
but this is probably good enough I suppose...:)